1339 / 1163: [Baltic2008]Mafia

1163: [Baltic2008]Mafia

Time Limit: 10 Sec  Memory Limit: 162 MB
Submit: 96  Solved: 60
[Submit][Status][Discuss]

Description

匪徒准备从一个车站转移毒品到另一个车站,警方准备进行布控. 对于每个车站进行布控都需要一定的代价,现在警方希望使用最小的代价控制一些车站,使得去掉这些车站后,匪徒无法从原定的初始点到达目标点

Input

第一行输入N,M代表车站的总个数,及有多少条双向边连接它们. 2<=n<=200 , 1 <=m<=20000. 第二行给出两个数a,b,代表匪徒的出发点及目标点.1<=a,b<=N,a<>b. 再下来有N行,给出对第i个车站进行布控所需要的Money,其不超过10 000 000 再下来M行,用于描述图的结构.

Output

最少需要多少Money

Sample Input

5 6
5 3
2
4
8
3
10
1 5
1 2
2 4
4 5
2 3
3 4

Sample Output

5

HINT

Source

题解:一个呵呵呵的最小割,将每个题目中的车站拆分成两个点,然后连接上一条边权为该站点费用的边,然后别的题目中所述的边直接连双向边,注意别弄乱了就是了

 1 /**************************************************************
 2     Problem: 1163
 3     User: HansBug
 4     Language: Pascal
 5     Result: Accepted
 6     Time:156 ms
 7     Memory:2652 kb
 8 ****************************************************************/
 9
10 type
11     point=^node;
12     node=record
13                g,w:longint;
14                next,anti:point;
15     end;
16 var
17    i,j,k,l,m,n,s,t,ans:longint;
18    a:array[0..5000] of point;
19    d,dv:array[0..5000] of longint;
20 function min(x,y:longint):longint;
21          begin
22               if x<y then min:=x else min:=y;
23          end;
24 procedure add(x,y,z:longint);
25           var p:point;
26           begin
27                new(p);p^.g:=y;p^.w:=z;p^.next:=a[x];a[x]:=p;
28                new(p);p^.g:=x;p^.w:=0;p^.next:=a[y];a[y]:=p;
29                a[x]^.anti:=a[y];a[y]^.anti:=a[x];
30           end;
31 function dfs(x,flow:longint):longint;
32          var p:point;k:longint;
33          begin
34               if x=t then exit(flow);
35               dfs:=0;p:=a[x];
36               while p<>nil do
37                     begin
38                          if (p^.w<>0) and (d[x]=(d[p^.g]+1)) then
39                             begin
40                                  k:=dfs(p^.g,min(flow-dfs,p^.w));
41                                  if p^.w<>maxlongint then dec(p^.w,k);
42                                  if p^.anti^.w<>maxlongint then inc(p^.anti^.w,k);
43                                  inc(dfs,k);if dfs=flow then exit;
44                             end;
45                          p:=p^.next;
46                     end;
47               if d[s]=n then exit;
48               dec(dv[d[x]]);
49               if dv[d[x]]=0 then d[s]:=n;
50               inc(d[x]);inc(dv[d[x]]);
51          end;
52 begin
53      readln(n,m);
54      for i:=1 to n*2 do a[i]:=nil;
55      readln(s,t);s:=s*2-1;t:=t*2;
56      for i:=1 to n do
57          begin
58               readln(j);
59               add(i*2-1,i*2,j);
60          end;
61      for i:=1 to m do
62          begin
63               readln(j,k);
64               add(j*2,k*2-1,maxlongint);
65               add(k*2,j*2-1,maxlongint);
66          end;
67      fillchar(dv,sizeof(dv),0);
68      fillchar(d,sizeof(d),0);
69      ans:=0;n:=n*2;
70      while d[s]<n do inc(ans,dfs(s,maxlongint));
71      writeln(ans);
72      readln;
73 end.
时间: 2024-12-23 19:13:30

1339 / 1163: [Baltic2008]Mafia的相关文章

1163: [Baltic2008]Mafia

1163: [Baltic2008]Mafia Time Limit: 10 Sec  Memory Limit: 162 MBSubmit: 123  Solved: 70[Submit][Status][Discuss] Description 匪徒准备从一个车站转移毒品到另一个车站,警方准备进行布控. 对于每个车站进行布控都需要一定的代价,现在警方希望使用最小的代价控制一些车站,使得去掉这些车站后,匪徒无法从原定的初始点到达目标点 Input 第一行输入N,M代表车站的总个数,及有多少条双

bzoj1339/1163:[Baltic2008]Mafia

传送门 最小割,割点,模板... 代码: #include<cstdio> #include<iostream> #include<algorithm> #include<queue> #include<cstring> using namespace std; void read(int &x) { char ch; bool ok; for(ok=0,ch=getchar(); !isdigit(ch); ch=getchar())

BZOJ 1339 Baltic 2008 Mafia 最小点割集

题目大意:一个城市中有些点,有一些双向道路将这些点连接起来,每个点都有权值,求警察最少占据的点的权值和使得从A点无法到达B点. 思路:最小点割集签到题. CODE: #include <queue> #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> #define MAX 80010 #define INF 0x3f3f3f3f using

HDU 1163 Eddy&#39;s digital Roots

Eddy's digital Roots Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 5783    Accepted Submission(s): 3180 Problem Description The digital root of a positive integer is found by summing the digit

POJ 1163 The Triangle

题目链接:http://poj.org/problem?id=1163 The Triangle Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 39022   Accepted: 23430 Description 7 3 8 8 1 0 2 7 4 4 4 5 2 6 5 (Figure 1) Figure 1 shows a number triangle. Write a program that calculat

1163 最高的奖励 贪心 + 并查集

http://www.51nod.com/onlineJudge/questionCode.html#!problemId=1163 首先如果时间大于n,也就是相当于不限时了,因为完成前n - 1项任务需要时间n - 1,不影响我的第n项. 首先按价值排序,然后这个价值安排在它准备过期的那一天,如果被占据了,就找下一天,就能优先吃到了最大值.而且你吃其他也是耗费一个空间,所以吃个更大的是最优的. 然后可以用并查集来维护,记录topre[i]表示第i个位置的上一个空位是谁. 就能加速找到了. 不然

51nod 1163 最高的奖励(贪心+优先队列)

题目链接:51nod 1163 最高的奖励 看着这题我立马就想到昨天也做了一道贪心加优先队列的题了奥. 按任务最晚结束时间从小到大排序,依次选择任务,如果该任务最晚结束时间比当前时间点晚,则将该任务的奖励值压入队列,否则将队列中最小的任务的奖励值替换,优先队列按奖励值小的优先. 1 #include<cstdio> 2 #include<cstring> 3 #include<algorithm> 4 #include<queue> 5 using name

ural 1339. Babies

1339. Babies Time limit: 1.0 secondMemory limit: 64 MB O tempora! O mores! Present-day babies progress quickly. There are exactly k boys and k girls in the kindergarten. Some boys like some girls. But in this age the boys are still knights, so, if so

题目1163:素数

题目描述: 输入一个整数n(2<=n<=10000),要求输出所有从1到这个整数之间(不包括1和这个整数)个位为1的素数,如果没有则输出-1. 输入: 输入有多组数据. 每组一行,输入n. 输出: 输出所有从1到这个整数之间(不包括1和这个整数)个位为1的素数(素数之间用空格隔开,最后一个素数后面没有空格),如果没有则输出-1. 样例输入: 100 样例输出: 11 31 41 61 71 C++代码: #include<iostream> using namespace std;